<template>
  <div ref="formContainer" class="formContainer invisible">
    <div class="formLimiter">
      <DynamicFormInputField
        ref="teamNameField"
        class="stretch">
      </DynamicFormInputField>
      <ActionButton
        class="forceItemToRow"
        ref="teamSubmitButton"
        :method="handleFormSubmit"
        buttonText="Add new team">
      </ActionButton>
      <ActionButton
        class="forceItemToRow"
        ref="teamCancelButton"
        :method="closeForm"
        buttonText="Cancel">
      </ActionButton>
    </div>
  </div>
</template>

<script>
import DynamicFormInputField from './DynamicFormInputField';
import ActionButton from './ActionButton';

export default {
  name: 'AddTeamForm',
  components: {
    ActionButton,
    DynamicFormInputField,
  },
  methods: {
    handleFormSubmit() {
      const that = this;
      const fieldTeamName = this.$refs.teamNameField.$refs.dynamicFormInput;
      const submitButton = this.$refs.teamSubmitButton.$refs.dynamicActionButton;

      if (fieldTeamName.value.trim() !== '') {
        fieldTeamName.style.background = 'rgb(0, 255, 0)';
        submitButton.disabled = true;

        const payload = {};
        payload.teamName = fieldTeamName.value;
        payload.members = [];
        that.$store.commit('saveNewTeam', payload);

        setTimeout(() => {
          that.closeForm(submitButton);
        }, 100);
      } else {
        fieldTeamName.style.background = 'rgb(255, 0, 0)';
      }
    },
    closeForm(submitButton) {
      const formContainer = this.$refs.formContainer;
      if (formContainer.classList.contains('visible')) {
        formContainer.classList.remove('visible');
        formContainer.classList.add('invisible');
      }
      this.clearForm(submitButton);
    },
    clearForm(submitButton) {
      const teamNameField = this.$refs.teamNameField.$refs.dynamicFormInput;
      const localSubmitButton = submitButton;
      teamNameField.value = '';
      teamNameField.style.background = 'rgb(255, 255, 255)';
      localSubmitButton.disabled = false;
    },
  },
};
</script>

<style scoped>
  .stretch {
    width: 100%;
  }
  .visible {
    display: block;
  }
  .invisible {
    display: none;
  }
  .formContainer {
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    height: 100vh;
    background: rgba(0, 0, 0, 0.4);
    z-index: 10;
  }
  .formLimiter {
    position: absolute;
    top: calc(50% - 100px);
    left: calc(50% - 100px);
    width: 200px;
    height: 200px;
  }
  .forceItemToRow {
    display: inline-block;
  }
</style>
